/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  J[lp̃X^[gAbvW[(SH2p)
 */

#define _MACRO_ONLY
#include "cpu_config.h"
#include "sys_defs.h"

/*
 *  ZNV`̃CN[h
 */

/*	OQƐ錾 */
	.globl	hardware_init_hook
	.globl	software_init_hook
	.globl	_main

	.section ".text" , "ax"
	.align	2
/*
 *  Zbg͂vOJn
 */
	.globl _start
_start:
	/*
	 *  SRݒ
	 */
	mov.l	maxipm , r0
	ldc 	r0 , sr
	
	/*
	 *  ݃X^bN|C^
	 */
	mov.l	stack_init, r15
	
	/*
	 *  荞݃xN^擪Ԓnݒ
	 */
	mov.l	vbr_init, r0
	ldc	r0 , vbr
	
	/*
	 *  hardware_init_hook ̌ďoi0 łȂꍇj
	 *
	 *  ^[Qbgn[hEFAɈˑĕKvȏꍇ
	 *  ́Chardware_init_hook Ƃ֐pӂD
	 */
	mov.l	hardware_init_hook_adr , r1
	tst		r1 , r1
	bt		hardware_init_hook_r
	jsr		@r1
	nop
hardware_init_hook_r:

	/*
	 *  bss̈̃[NA
	 */
	mov.l	_bss_start_adr , r0
	mov.l	_bss_end_adr , r1
	mov		#0 , r2
bss_clear_loop:
	cmp/ge	r1 , r0
	bt		bss_clear_end
	mov.l	r2 , @r0
	add		#4 , r0
	bra		bss_clear_loop
bss_clear_end:
	/*
	 *  datä̏
	 */
	mov.l   __idata_start_adr,r1
	mov.l   __idata_end_adr,r2
	cmp/eq  r1,r2
	bt      data_init_end
	mov.l   __data_start_adr,r0
data_init:
	mov.l   @r1+,r4
	mov.l   r4,@r0
	cmp/hi  r1,r2
	add     #4,r0
	bt      data_init
data_init_end:
	/*
	 *  software_init_hook ďoi0 łȂꍇj
	 *
	 *  \tgEFAiɃCujɈˑĕKvȏ
	 *  ꍇ́Csoftware_init_hook Ƃ֐pӂ
	 *  悢D
	 */
	mov.l	software_init_hook_adr , r1
	tst		r1 , r1
	bt		software_init_hook_r
	jsr		@r1
	nop
software_init_hook_r:
	/*
	 *  [U[C֐փWv
	*/
	mov.l	main_adr , r0
	jsr	@r0
	nop
exit_loop:
	/*
	 *  main߂Ăꍇ͈Ŝߖ[v
	 */
	bra	exit_loop
	nop

stack_init:
	.long	STACK_TOP
vbr_init:
	.long	VECTOR_TOP
hardware_init_hook_adr:
	.long	_hardware_init_hook
software_init_hook_adr:
	.long	_software_init_hook
_bss_start_adr:
	.long	__bss_start
_bss_end_adr:
	.long	__bss_end
main_adr:
	.long	_main
maxipm:
	.long	0x000000f0
	
__idata_start_adr:
	.long 	__idata_start
__idata_end_adr:
	.long   __idata_end
__data_start_adr:
	.long  	__data_start

	.end
